田草博客





网友交流群:11740834 需注明申请加入原因

邮箱:tiancao1001x126.com
日志首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范
-电信用户-|-网通用户-
-博客论坛-|-软件下载-
-网站导航-|-建筑书店-
-BelovedFLash欣赏-
-来路-|-随机-|-分布-

用户登陆
用户:
密码:
 

站点日历
73 2017 - 10 48
1234567
891011121314
15161718192021
22232425262728
293031


站点统计

最新评论

日志搜索

 标题   内容 评论


用PL2将PL1线打断后,删除PL2内部部分,保留外部部分 判断点是否在pl线上
未知 IntersectWith   [ 日期:2017-09-13 ]   [ 来自:本站原创 ]  HTML



 <CommandMethod("inters", CommandFlags.UsePickSet)> _
    Public Sub GetInters()
        Dim doc As Document = acadApp.DocumentManager.MdiActiveDocument
        Dim db As Database = doc.Database
        Dim ed As Editor = doc.Editor
        Dim tr As Transaction = db.TransactionManager.StartTransaction
        Try
            Using (tr)
                Dim opt As New PromptEntityOptions(vbLf & "Select line: ")
                opt.SetRejectMessage(vbLf & "Select line only")
                opt.AllowNone = False
                opt.AllowObjectOnLockedLayer = True
                opt.AddAllowedClass(GetType(Line), True)
                Dim res As PromptEntityResult = ed.GetEntity(opt)
                If res.Status <> PromptStatus.OK Then Return
                Dim lid As ObjectId = res.ObjectId
                opt.AddAllowedClass(GetType(Polyline), True)
                opt.SetRejectMessage(vbLf & "Select polyline only")
                opt.Message = vbLf & "Select polyline: "
                res = ed.GetEntity(opt)
                If res.Status <> PromptStatus.OK Then Return
                Dim pid As ObjectId = res.ObjectId
                Dim pts As Point3dCollection = New Point3dCollection()
                ed.WriteMessage(vbLf & "{0} <> {1};", lid, pid)
                Dim enl As Line = CType(tr.GetObject(lid, OpenMode.ForRead), Line)
                Dim enp As Polyline = CType(tr.GetObject(pid, OpenMode.ForRead), Polyline)
                Dim plane As Plane = New Plane(ed.CurrentUserCoordinateSystem.CoordinateSystem3d.Origin, ed.CurrentUserCoordinateSystem.CoordinateSystem3d.Zaxis)
                enl.IntersectWith(enp, Intersect.OnBothOperands, plane, pts, 0, 0)
                ed.WriteMessage(vbLf & "Number of intersections: {0}", pts.Count)
                Dim i As Integer = 1
                For Each pt As Point3d In pts
                    ed.WriteMessage(vbLf & "Point number {0}: ({1}, {2}, {3})", i, pt.X, pt.Y, pt.Z)
                    i += 1
                Next
                tr.Commit()
            End Using
        Catch ex As Autodesk.AutoCAD.Runtime.Exception
            ed.WriteMessage(vbLf & "{0}", ex.Message)
        End Try
    End Sub




[本日志由 tiancao1001 于 2017-09-13 11:48 PM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:1*7=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
版权所有:田草博客
tiancao1001&126.com网友交流QQ群:11740834
Powered by L-Blog V1.08 (SE) Final© 2007-2009